LibTransition = LibStub("LibTransition-1.0");
Combustion_UpdateInterval = 0.1; -- How often the OnUpdate code will run (in seconds)
local lvb,ffb,ignite,pyro1,pyro2,comb 
local LBTime,FFBTime,IgnTime,PyroTime,CombustionUp,ffbglyph,combufadeout
 
function Combustion_OnLoad(frame)
	frame:RegisterForDrag("LeftButton")
	frame:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded
	frame:RegisterEvent("PLAYER_TALENT_UPDATE")
    ChatFrame1:AddMessage("|cff00ffffCombustion Helper is loaded. Type /combustionhelper for config.|r")
    lvb = GetSpellInfo(44457) 
    ffb = GetSpellInfo(44614) 
    ignite = GetSpellInfo(12654) 
    pyro1 = GetSpellInfo(11366) 
    pyro2 = GetSpellInfo(92315) 
    comb = GetSpellInfo(11129)   
    LibTransition:Attach(CombustionFrame)

    local a6 = IsSpellKnown(11129) -- check if combustion is in the spellbook
    if (a6 == false) then combuhide = true
    elseif (a6 == true) then combuhide = false
    end
    
    if (combuautohide == nil) then combuautohide = true
    end
end

function Combustion_OnEvent(self, event, ...)

    if (event == "ADDON_LOADED") or (event == "PLAYER_TALENT_UPDATE") then
            
            local a6 = IsSpellKnown(11129) -- check if combustion is in the spellbook
            for i = 1,9 do local enabled,_,_,id = GetGlyphSocketInfo(i)
            
            if (id == 61205) then ffbglyph = true
            else ffbglyph = false
            end 
                
            if (a6 == false) and (combuhide == false) then
                    CombustionFrame:FadeOut(2);
                    combuhide = true
                    ChatFrame1:AddMessage("|cff00ffffNo Combustion spell in Spellbook, hiding now.|r")
            elseif (a6 == true) and (combuhide == true) then
                    CombustionFrame:FadeIn(2);
                    combuhide = false
                    ChatFrame1:AddMessage("|cff00ffffCombustion spell in Spellbook, back in.|r")
            end

            if (combulock == false) then CombustionFrame:EnableMouse(true) -- check variables for lock/unlock
            elseif (combulock == true) then CombustionFrame:EnableMouse(false)
            end
	 
            if (ffbglyph == false) and (combuhide == false) and (combuffb == true) then 		
                ChatFrame1:AddMessage("|cff00ffffFrostfire Bolt disabled|r")
                FFBButtonFrame:Hide()
                FFBTextFrame:Hide()
                FFB:Hide()
                StatusTextFrame:SetPoint("TOPLEFT",CombustionFrame,"TOPLEFT",6,-32)
                CombustionFrame:SetHeight(48)
                combuffb = false
            elseif (ffbglyph==true) and (combuhide == false) and (combuffb == false) then 		
                	ChatFrame1:AddMessage("|cff00ffffFrostfire Bolt enabled|r")
                	FFBButtonFrame:Show()
                	FFBTextFrame:Show()
                	FFB:Show()
                	StatusTextFrame:SetPoint("TOPLEFT",CombustionFrame,"TOPLEFT",6,-41)
                	CombustionFrame:SetHeight(56)
                	combuffb = true
            elseif (combuffb == false) then 		
           	  	   	FFBButtonFrame:Hide()
            	    FFBTextFrame:Hide()
                	FFB:Hide()
                	StatusTextFrame:SetPoint("TOPLEFT",CombustionFrame,"TOPLEFT",6,-32)
                	CombustionFrame:SetHeight(48)
            elseif (combuffb == true) then 		
           	  	   	FFBButtonFrame:Show()
                	FFBTextFrame:Show()
                	FFB:Show()
                	StatusTextFrame:SetPoint("TOPLEFT",CombustionFrame,"TOPLEFT",6,-41)
                	CombustionFrame:SetHeight(56)
            elseif (ffbglyph == false) then 		
           	  	   	FFBButtonFrame:Hide()
            	    FFBTextFrame:Hide()
                	FFB:Hide()
                	StatusTextFrame:SetPoint("TOPLEFT",CombustionFrame,"TOPLEFT",6,-32)
                	CombustionFrame:SetHeight(48)
                    combuffb = false
            end  	
        end
    end
end

function Combustion_OnUpdate(self, elapsed)
    self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed;
 
		if (self.TimeSinceLastUpdate > Combustion_UpdateInterval) then
            local time = GetTime()   
-------------------------------
			local a,b,c,d,e,f,g,h,i,j,k = UnitAura("target", lvb, nil, "PLAYER HARMFUL")		

			if (k==44457) and ((-1*(time-g))>=2) -- condition when timer is with more than 2 seconds left
			then LBTextFrameLabel:SetText(format("|cff00ff00%.1f|r",-1*(time-g)))
			     LBButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 LBTime = 1
--Living Bomb part
			elseif (k==44457) and ((-1*(time-g))<=2) -- condition when timer is with less than 2 seconds left
			then LBTextFrameLabel:SetText(format("|cffff0000%.1f|r",-1*(time-g)))
			     LBButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 LBTime = 0

			else LBTextFrameLabel:SetText(format("|cffff0000LB|r")) 
			     LBButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionoff") -- Text in red
                 LBTime = 0
			end
--------------------------------
			local a1,b1,c1,d1,e1,f1,g1,h1,i1,j1,k1 = UnitAura("target", ffb, nil, "PLAYER HARMFUL")		

			if (combuffb == false)
			then FFBTextFrameLabel:SetText(format("|cffff0000FFB|r"))
				 FFBTime = 1
			
			elseif (k1==44614) and ((-1*(time-g1))>=2) -- condition when timer is with more than 2 seconds left
			then FFBTextFrameLabel:SetText(format("|cff00ff00%.1f/%d|r",-1*(time-g1),(d1)))
			     FFBButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 FFBTime = 1
--FrostfireBolt part
			elseif (k1==44614) and ((-1*(time-g1))<=2) -- condition when timer is with less than 2 seconds left
			then FFBTextFrameLabel:SetText(format("|cffff0000%.1f/%d|r",-1*(time-g1),(d1)))
			     FFBButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 FFBTime = 0

			else FFBTextFrameLabel:SetText(format("|cffff0000FFB|r"))
			     FFBButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionoff") -- Text in red
                 FFBTime = 0
			end
--------------------------------
			local a2,b2,c2,d2,e2,f2,g2,h2,i2,j2,k2 = UnitAura("target", ignite, nil, "PLAYER HARMFUL")		

			if (k2==12654) and ((-1*(time-g2))>=2) -- condition when timer is with more than 2 seconds left
			then IgnTextFrameLabel:SetText(format("|cff00ff00%.1f|r",-1*(time-g2)))
			     IgniteButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 IgnTime = 1
--Ignite part
			elseif (k2==12654) and ((-1*(time-g2))<=2) -- condition when timer is with less than 2 seconds left
			then IgnTextFrameLabel:SetText(format("|cffff0000%.1f|r",-1*(time-g2)))
			     IgniteButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 IgnTime = 0

			else IgnTextFrameLabel:SetText(format("|cffff0000Ign|r"))
			     IgniteButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionoff") -- Text in red
                 IgnTime = 0
			end
--------------------------------
			local a3,b3,c3,d3,e3,f3,g3,h3,i3,j3,k3 = UnitAura("target", pyro1, nil, "PLAYER HARMFUL")		
			local a4,b4,c4,d4,e4,f4,g4,h4,i4,j4,k4 = UnitAura("target", pyro2, nil, "PLAYER HARMFUL")		

			if (k3==11366) and ((-1*(time-g3))>=2) -- condition when timer is with more than 2 seconds left
			then PyroTextFrameLabel:SetText(format("|cff00ff00%.1f|r",-1*(time-g3)))
			     PyroButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 PyroTime = 1
                 
			elseif (k4==92315) and ((-1*(time-g4))>=2) -- condition when timer is with more than 2 seconds left
			then PyroTextFrameLabel:SetText(format("|cff00ff00%.1f|r",-1*(time-g4)))
			     PyroButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 PyroTime = 1
--Pyroblast part
			elseif (k3==11366) and ((-1*(time-g3))<=2) -- condition when timer is with less than 2 seconds left
			then PyroTextFrameLabel:SetText(format("|cffff0000%.1f|r",-1*(time-g3)))
			     PyroButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 PyroTime = 0

			elseif (k4==92315) and ((-1*(time-g4))<=2) -- condition when timer is with less than 2 seconds left
			then PyroTextFrameLabel:SetText(format("|cffff0000%.1f|r",-1*(time-g4)))
			     PyroButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionon")
                 PyroTime = 0

                 else PyroTextFrameLabel:SetText(format("|cffff0000Pyro|r"))
			     PyroButton:SetTexture("Interface\\AddOns\\CombustionHelper\\Images\\Combustionoff") -- Text in red
			     PyroTime = 0
            end
--------------------------------
			local a5,b5,c5 = GetSpellCooldown(comb)
			
			if (b5 == nil) then
            
			elseif (b5<=2) -- condition when combustion cd is up, taking gcd in account
			then StatusTextFrameLabel:SetText(format("Combustion Up !"))
				 CombustionUp = 1
				 combufadeout = false
--Combustion part            
 			elseif ((a5 + b5 - time)>=60) and (combufadeout == false)
            then StatusTextFrameLabel:SetText(format("Combustion in %d:%0.2d",(a5 + b5 - time) / 60,(a5 + b5 - time) % 60 ))  -- timer for combustion in minutes
				 CombustionUp = 0
                 
 			elseif ((a5 + b5 - time)<=60)
            then StatusTextFrameLabel:SetText(format("Combustion in %.0fsec",(a5 + b5 - time)))  -- timer for combustion in seconds
				 CombustionUp = 0	
				
			end
			
--------------------------------

            if (LBTime == 1) 
            and (FFBTime == 1) 
            and (IgnTime == 1) 
            and (PyroTime == 1) 
            and (CombustionUp == 1)
--Green background for frame when dots and combustion are up
            then CombustionFrame:SetBackdropColor(0,0.7,0)
            else CombustionFrame:SetBackdropColor(0.2509804,0.2509804,0.2509804)
            end
            
--------------------------------

			if (a5 == nil) then
			elseif ((a5 + b5 - time) <= 105) and ((a5 + b5 - time) >= 18) and (combufadeout == false) and (combuautohide == true)
            then combufadeout = true
             	 StatusTextFrameLabel:SetText(format("Autohiding now.")) -- autohide part for fade out
				 CombustionFrame:FadeOut(3);
				 CombustionFrame:Wait(86);
				 CombustionFrame:FadeIn(2);
			end
			
--------------------------------

		self.TimeSinceLastUpdate = 0;

    end    
end

--------------------------------------------
SLASH_COMBUCONFIG1 = "/combustionhelper"

SlashCmdList["COMBUCONFIG"] = function(msg)
	if msg=="lock" then
		combulock = true
		CombustionFrame:EnableMouse(false)
		ChatFrame1:AddMessage("|cff00ffffCombustion Helper is locked|r")

	elseif msg=="unlock" then
		combulock = false
		CombustionFrame:EnableMouse(true)
		ChatFrame1:AddMessage("|cff00ffffCombustion Helper is unlocked|r")

	elseif msg=="ffbon" then
		combuffb = true
		ChatFrame1:AddMessage("|cff00ffffFrostfire Bolt enabled|r")
		FFBButtonFrame:Show()
		FFBTextFrame:Show()
		FFB:Show()
		StatusTextFrame:SetPoint("TOPLEFT",CombustionFrame,"TOPLEFT",6,-41)
		CombustionFrame:SetHeight(57)
		
	elseif msg=="ffboff" then
		combuffb = false
		ChatFrame1:AddMessage("|cff00ffffFrostfire Bolt disabled|r")
		FFBButtonFrame:Hide()
		FFBTextFrame:Hide()
		FFB:Hide()
		StatusTextFrame:SetPoint("TOPLEFT",CombustionFrame,"TOPLEFT",6,-32)
		CombustionFrame:SetHeight(48)
				
	elseif msg=="hide" then
 		combuhide = true
        CombustionFrame:FadeOut(2);
		ChatFrame1:AddMessage("|cff00ffffCombustion Helper is hidden now|r")

	elseif msg=="show" then
 		combuhide = false
        CombustionFrame:FadeIn(2);
		ChatFrame1:AddMessage("|cff00ffffCombustion Helper is showing now|r")
		
	elseif msg=="autohideoff" then
 		combuautohide = false
		ChatFrame1:AddMessage("|cff00ffffCombustion Helper autohide off|r")		

	elseif msg=="autohideon" then
 		combuautohide = true
		ChatFrame1:AddMessage("|cff00ffffCombustion Helper autohide on|r")
							
	elseif msg=="" or msg=="help" or msg=="?" then
		ChatFrame1:AddMessage("/combustionhelper lock |cffffff00- Lock Combustion Helper|r")
		ChatFrame1:AddMessage("/combustionhelper unlock |cffffff00- Unlock Combustion Helper|r")
		ChatFrame1:AddMessage("/combustionhelper ffbon |cffffff00- Enable Frostfire Bolt|r")
		ChatFrame1:AddMessage("/combustionhelper ffboff |cffffff00- Disable Frostfire Bolt|r")
		ChatFrame1:AddMessage("/combustionhelper hide |cffffff00- Hide Combustion Helper|r")
		ChatFrame1:AddMessage("/combustionhelper show |cffffff00- Show Combustion Helper|r")
		ChatFrame1:AddMessage("/combustionhelper autohideon |cffffff00- Enable Combustion Helper autohide|r")
		ChatFrame1:AddMessage("/combustionhelper autohideoff |cffffff00- Disable Combustion Helper autohide|r")
		
	else
		ChatFrame1:AddMessage("|cffffff00CombustionHelper: Unknown command, type '/combustionhelper' for help.|r")
	end

end